##choosingColonies
###MODDER READ THIS:
####this file has to be in the main python folder (not really, can also be somewhere in the subfolders)
####the 2 variables bUnrestrictedLeaders and bEverythingColony are there for customization
####if bUnrestrictedLeaders is set to True, you'll be able to give your new colony leader
####a random civilization, so Monty of the Carthagians, etc.
####if bEverythingColony is set to True, you'll also be able to make 1 city colonies

bUnrestrictedLeaders = False
bEverythingColony = False

import gc as garbage
from CvPythonExtensions import *
import sys
gc = CyGlobalContext()
iMaxPlayer = gc.getMAX_CIV_PLAYERS ()
lCities = []
lColonyLists = []
lLibCities = []

class cityLists:
    def __init__(self,areaID):
        self.iArea = areaID
        self.lCities = []

def doPopup():    
    for i in xrange (iMaxPlayer):
        PotPlayer = gc.getPlayer(i)
        if PotPlayer.isHuman():
            pPlayer = gc.getPlayer(i)
            break
    iPlayer = pPlayer.getID()
    pCapital = pPlayer.getCapitalCity()
    iMainArea = pCapital.area().getID()

    lAreas = []
    del lCities[:]
    del lLibCities[:]
    del lAreas[:]
    (loopCity, iter) = pPlayer.firstCity(false)
    while(loopCity):        
        iCurrentArea = loopCity.area().getID()
        if iCurrentArea!=iMainArea:
            lCities.append(loopCity)
            if not iCurrentArea in lAreas:
                lAreas.append(iCurrentArea)
        if loopCity.getLiberationPlayer(False)!=-1:
            lLibCities.append(loopCity)
        (loopCity, iter) = pPlayer.nextCity(iter, false)

    global lColonyLists
    del lColonyLists[:]
    for iArea in lAreas:
        newArea = cityLists(iArea)       
        for city in lCities:
            if city.area().getID()==iArea:
                newArea.lCities.append(city)
        lColonyLists.append(newArea)
    lColonyLists = cleanList()
        
    if (not lCities) and (not lLibCities):
        return()

    popupInfo = CyPopupInfo()
    popupInfo.setButtonPopupType(ButtonPopupTypes.BUTTONPOPUP_PYTHON)
    popupInfo.setText(CyTranslator().getText("TXT_KEY_FREE_COLONY",()))
    popupInfo.setData1(iPlayer)
    popupInfo.setOnClickedPythonCallback("doColony")

    for area in lColonyLists:
        sText = ""
        for city in area.lCities:
            sText = sText + city.getName()+", "
        sText = sText[:-2]        
        popupInfo.addPythonButton(CyTranslator().getText("TXT_KEY_SPLIT_EMPIRE",(sText,sText)),"art\\interface\\buttons\\builds\\buildvillage.dds")
    for cities in lLibCities:
        sCityName = cities.getName()
        pLibPlayer = gc.getPlayer(cities.getLiberationPlayer(False))
        sPlayerName = pLibPlayer.getName()
        popupInfo.addPythonButton(CyTranslator().getText("TXT_KEY_CITY_LIBERATE",(sCityName,sPlayerName)),"art\\interface\\buttons\\builds\\buildvillage.dds")
    popupInfo.addPythonButton(CyTranslator().getText("TXT_KEY_NEVER_MIND",()),"art\\interface\\buttons\\actions\\cancel.dds")
    garbage.collect()
    popupInfo.addPopup(iPlayer) 
    

def doColony(argsList):
    iButton = argsList[0]
    iPlayer = argsList[1]
    MapName = CyMap().getMapScriptName ()
    i=0
    iLenColonies = len(lColonyLists)
    if iButton < iLenColonies:
        pCity = lColonyLists[iButton].lCities[0]
    else:
        if iButton-iLenColonies <len(lLibCities):
            liberateCity(lLibCities[iButton-iLenColonies])
        return
    
    iArea = pCity.area().getID()
    popupInfo = CyPopupInfo()
    popupInfo.setButtonPopupType(ButtonPopupTypes.BUTTONPOPUP_PYTHON)
    popupInfo.setText(CyTranslator().getText("TXT_KEY_CHOOSE_VASSAL_LEADER",()))
    popupInfo.setData1(iPlayer)
    popupInfo.setData2(iArea)
    popupInfo.setOnClickedPythonCallback("chooseLeaderType")
    lLeaders = []
    lLeaders = getKnownLeaders(iPlayer)

    iAllLeaders = gc.getNumLeaderHeadInfos ()
    for i in xrange (iAllLeaders):
            if not i in lLeaders:                
                cvType = gc.getLeaderHeadInfo(i)         
                popupInfo.addPythonButton(cvType.getDescription(), cvType.getButton ())

    popupInfo.addPythonButton(CyTranslator().getText("TXT_KEY_NEVER_MIND",()),"art\\interface\\buttons\\actions\\cancel.dds")
    garbage.collect()
    popupInfo.addPopup(iPlayer) 



def chooseLeaderType(argsList):
    iInterimLeaderID = argsList[0]    
    iPlayer = argsList[1]
    iArea = argsList[2]
    global gc 

    lLeaders = []
    lLeaders = getKnownLeaders(iPlayer)
    iCount = 0    
    iAllLeaders = gc.getNumLeaderHeadInfos ()
    for i in xrange (iAllLeaders):
        if not i in lLeaders:
            cvType = gc.getLeaderHeadInfo(i)                            
            if iInterimLeaderID ==iCount:
                iLeaderID =i
                break
            iCount = iCount+1
    else:
        return
    if not bUnrestrictedLeaders and (not gc.getGame().isOption(GameOptionTypes.GAMEOPTION_LEAD_ANY_CIV)):
        AddLeader(iPlayer,iArea,iLeaderID,None)
        return
   
    
    
    popupInfo = CyPopupInfo()
    popupInfo.setButtonPopupType(ButtonPopupTypes.BUTTONPOPUP_PYTHON)
    popupInfo.setText(CyTranslator().getText("TXT_KEY_CHOOSE_VASSAL_CIV",()))
    popupInfo.setData1(iPlayer)
    popupInfo.setData2(iArea)
    popupInfo.setData3(iLeaderID)
    popupInfo.setOnClickedPythonCallback("chooseCivType")
    lCivs = []
    lCivs = getKnownCivs(iPlayer)
    iAllCiv = gc.getNumCivilizationInfos ()

    for i in xrange (iAllCiv):
        if not i in lCivs:
            cvType = gc.getCivilizationInfo(i)
            if cvType.isPlayable():
                popupInfo.addPythonButton(cvType.getDescription(), cvType.getButton ())        

    popupInfo.addPythonButton(CyTranslator().getText("TXT_KEY_NEVER_MIND",()),"art\\interface\\buttons\\actions\\cancel.dds")
    garbage.collect()
    popupInfo.addPopup(iPlayer)

def chooseCivType(argsList):
    iCivTypeInterim = argsList[0]        
    iPlayer = argsList[1]
    iArea = argsList[2]
    iLeaderID = argsList[3]
    iCount = 0
    lCivs = []
    lCivs = getKnownCivs(iPlayer)    
    iAllCiv = gc.getNumCivilizationInfos ()
    for i in xrange (iAllCiv):
        if not i in lCivs:
            cvType = gc.getCivilizationInfo(i)
            if cvType.isPlayable():                
                if iCivTypeInterim ==iCount:
                    iCivType =i
                    break
                iCount = iCount+1
    else:
        return
    garbage.collect()
    AddLeader(iPlayer,iArea,iLeaderID,iCivType)

def AddLeader(iHumanPlayer,iArea,iLeaderID,iCivType):
        global gc
        pHumanPlayer = gc.getPlayer(iHumanPlayer)
        pHumanTeam = gc.getTeam(pHumanPlayer.getTeam())

        for NumCiv in xrange (gc.getMAX_PLAYERS ()):
                PotPlayer = gc.getPlayer(NumCiv)
                if not PotPlayer.isAlive():
                        NewID = NumCiv
                        break
        else:
                return            
        if not iCivType:
            iCivType = getCivType(iLeaderID)

        CyGame().addPlayer(NewID,iLeaderID,iCivType)
        pPlayer = gc.getPlayer(NewID)
        pPlayer.AI_changeMemoryCount(iHumanPlayer,30,10)
        pTeam = gc.getTeam(pPlayer.getTeam())
        pTeam.setVassal(pHumanPlayer.getTeam(),True,False)
        
	(loopCity, iter) = pHumanPlayer.firstCity(false)
	while(loopCity):
            if loopCity.area().getID()==iArea:
                iCulture = loopCity.getCulture(iHumanPlayer)
                pPlayer.acquireCity(loopCity,False,True)
                playerCity = pPlayer.firstCity(True)
                (playerCity,iter)=pPlayer.nextCity(iter,True)
                playerCity.setCulture(NewID,iCulture,True)
            (loopCity, iter) = pHumanPlayer.nextCity(iter, false)
        for iTechs in xrange(gc.getNumTechInfos ()):
                if pHumanTeam.isHasTech(iTechs):
                        pTeam.setHasTech(iTechs,True,NewID,False,False)
                        
	(loopCity, iter) = pPlayer.firstCity(false)
	sName = pHumanPlayer.getName()
	sVassalName = pPlayer.getName()
	sVassalCiv = pPlayer.getCivilizationShortDescription (0)  
	CyInterface().addMessage(iHumanPlayer,false,50,CyTranslator().getText("TXT_KEY_MISC_EMPIRE_SPLIT",(sName,sVassalCiv,sVassalName)),'',0,"",ColorTypes(gc.getInfoTypeForString("COLOR_CYAN")),loopCity.getX(),loopCity.getY(), True,True)
	while(loopCity):
            iConscript = loopCity.getConscriptUnit ()
            if iConscript<0:
                iConscript = getBestUnit(loopCity)
            pPlayer.initUnit(iConscript, loopCity.getX(), loopCity.getY(), UnitAITypes.UNITAI_GENERAL, DirectionTypes.NO_DIRECTION)
            pPlayer.initUnit(iConscript, loopCity.getX(), loopCity.getY(), UnitAITypes.UNITAI_GENERAL, DirectionTypes.NO_DIRECTION)
                
            (loopCity, iter) = pPlayer.nextCity(iter, false)


        garbage.collect()
      
def liberateCity(pCity):    
    iLibPlayer = pCity.getLiberationPlayer(False)
    pLibPlayer = gc.getPlayer(iLibPlayer)
    pLibPlayer.AI_changeMemoryCount(pCity.getOwner(),32,5)
    pLibPlayer.acquireCity(pCity,False,True)
    garbage.collect()

def getKnownCivs(iHumanPlayer):
    pHumanPlayer = gc.getPlayer(iHumanPlayer)
    iHumanTeam = pHumanPlayer.getTeam()
    lCivs = []
    for i in xrange (iMaxPlayer):
        pPlayer = gc.getPlayer(i)
        iTeam = pPlayer.getTeam()
        pTeam = gc.getTeam(iTeam)
        if pTeam.isHasMet(iHumanTeam) and (not pTeam.isBarbarian()):
            iType = pPlayer.getCivilizationType()
            lCivs.append(iType)   
    return lCivs

def getKnownLeaders(iHumanPlayer):
    pHumanPlayer = gc.getPlayer(iHumanPlayer)
    iHumanTeam = pHumanPlayer.getTeam()
    lLeaders = []
    for i in xrange (iMaxPlayer):
        pPlayer = gc.getPlayer(i)
        iTeam = pPlayer.getTeam()
        pTeam = gc.getTeam(iTeam)
        if pTeam.isHasMet(iHumanTeam) and (not pTeam.isBarbarian()):
            iType = pPlayer.getLeaderType()
            lLeaders.append(iType)
    lLeaders.append(gc.getDefineINT("BARBARIAN_LEADER"))            
    return lLeaders

def getCivType(iLeaderID):
    iAllCiv = gc.getNumCivilizationInfos ()
    for i in range(iAllCiv):
        cvCiv = gc.getCivilizationInfo(i)
        if cvCiv.isLeaders(iLeaderID):
            return i

def cleanList():
    if bEverythingColony:
        return lColonyLists
    iLenList = len(lColonyLists)
    MapName = CyMap().getMapScriptName ()
    for i in range(iLenList-1,-1,-1):
        if len(lColonyLists[i].lCities)<3:            
            if len(lColonyLists[i].lCities)==2:            
                if not MapName =="Archipelago":
                    lColonyLists.pop(i)
            else:
                lColonyLists.pop(i)
    return lColonyLists

def getBestUnit(pCity):
    global gc
    iNumUnits = gc.getNumUnitInfos ()
    pCurUnit = None
    for i in range(iNumUnits):
        if pCity.canTrain(i,True,False):
            cvUnit = gc.getUnitInfo(i)
            if cvUnit.getDomainType ()==gc.getInfoTypeForString("DOMAIN_LAND"):
                if not pCurUnit:
                    pCurUnit = cvUnit
                else:
                    if cvUnit.getCombat ()>pCurUnit.getCombat():
                        pCurUnit = cvUnit
    return gc.getInfoTypeForString(pCurUnit.getType())
                
    
        

                            
                        
